'use strict';

exports.__esModule = true;

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _helpers = require('./internals/helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Invoke function taked from result
 */
exports.default = (0, _helpers.defFactory)('branch', function (condition) {
  var onTrue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var onFalse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return function branch() {
    (0, _warning2.default)((0, _isFunction2.default)(condition), 'Condition must be a function');

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var payload = condition.apply(this, args);
    var callback = payload ? onTrue : onFalse;
    return (0, _isFunction2.default)(callback) ? callback.apply(this, args) : callback;
  };
});
module.exports = exports['default'];