'use strict';

exports.__esModule = true;

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

exports.defFactory = defFactory;
exports.isFactory = isFactory;
exports.getDisplayName = getDisplayName;
exports.forkResolver = forkResolver;

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function defFactory(displayName, fn, resolver) {
  var _ref;

  var _ = (_ref = {}, _ref[displayName] = function () {
    var word = fn.apply(undefined, arguments);
    if (resolver) {
      (0, _defineProperty2.default)(word, _constants.RESOLVER, {
        enumerable: false,
        writable: false,
        value: resolver
      });
    }
    return word;
  }, _ref);
  (0, _defineProperty2.default)(_[displayName], _constants.RECOMPOSITE, {
    enumerable: false,
    writable: false,
    configurable: false,
    value: {
      displayName: displayName,
      isFactory: true
    }
  });
  return _[displayName];
}

function isFactory(fn) {
  return (0, _isObject2.default)(fn) && fn[_constants.RECOMPOSITE] && fn[_constants.RECOMPOSITE].isFactory;
}

function getDisplayName(fn) {
  return (0, _isObject2.default)(fn) && fn[_constants.RECOMPOSITE] && fn[_constants.RECOMPOSITE].displayName;
}

function forkResolver(unit, stack, context) {
  unit.apply(context, stack.slice().reverse());
  return stack;
}