'use strict';

exports.__esModule = true;

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _helpers = require('./internals/helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Invoke function taked from result
 */
exports.default = (0, _helpers.defFactory)('invoke', function (fn) {
  return function invoke() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var payload = fn.apply(this, args);
    if ((0, _isFunction2.default)(payload)) {
      return payload.apply(this, args);
    } else if ((0, _isArray2.default)(payload) && (0, _isFunction2.default)(payload[0])) {
      return payload[0].apply(payload, payload.slice(1));
    }
    return payload;
  };
});
module.exports = exports['default'];