'use strict';

exports.__esModule = true;

var _helpers = require('./internals/helpers');

function strictEqual(a, b) {
  return a === b;
}

function shallowEqualArgs(isEqual, prevArgs, nextArgs) {
  if (prevArgs === undefined || prevArgs.length !== nextArgs.length) {
    return false;
  }
  var length = Math.max(prevArgs.length, nextArgs.length);
  for (var i = 0; i < length; i++) {
    if (!isEqual(prevArgs[i], nextArgs[i])) {
      return false;
    }
  }
  return true;
}

exports.default = (0, _helpers.defFactory)('memoize', function memoize(selector) {
  var _ref;

  var isEqual = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : strictEqual;

  var nextName = 'memoize' + (selector.name || '');
  var cachedArgs = void 0;
  var cachedResult = void 0;
  var _ = (_ref = {}, _ref[nextName] = function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (shallowEqualArgs(isEqual, cachedArgs, args)) {
      return cachedResult;
    }
    cachedArgs = args;
    cachedResult = selector.apply(undefined, args);
    return cachedResult;
  }, _ref);

  return _[nextName];
});
module.exports = exports['default'];