'use strict';

exports.__esModule = true;

var _isPromise = require('is-promise');

var _isPromise2 = _interopRequireDefault(_isPromise);

var _helpers = require('./internals/helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _helpers.defFactory)('then', function (handler, reject) {
  var _ref;

  var nextName = 'then' + (handler.name || 'Fn');
  var _ = (_ref = {}, _ref[nextName] = function (promise) {
    if ((0, _isPromise2.default)(promise)) {
      var nextPromise = promise.then(handler);
      if (reject) {
        return nextPromise.catch(reject);
      }
      return nextPromise;
    }

    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return handler.apply(undefined, [promise].concat(args));
  }, _ref);

  return _[nextName];
});
module.exports = exports['default'];