'use strict';

exports.__esModule = true;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

exports.default = tillTruly;

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _keys = require('lodash/keys');

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function defaultOnFail() {
  return undefined;
}

function tillTruly(variants, match) {
  var onFail = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultOnFail;

  var matcher = (0, _isFunction2.default)(match) ? match : function (result) {
    return result === match;
  };
  var isHashMap = !(0, _isArray2.default)(variants);
  var iterableKeys = isHashMap ? (0, _getIterator3.default)((0, _keys2.default)(variants)) : variants.keys();
  return function tillTrulyChain() {
    var next = iterableKeys.next();

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    while (!next.done) {
      var key = next.value;
      var result = (0, _isFunction2.default)(variants[key]) ? variants[key].apply(this, args) : variants[key];
      if (matcher.apply(this, [result].concat(args))) {
        return isHashMap ? key : result;
      }
      next = iterableKeys.next();
    }
    for (var i = 0; i < variants.length; i++) {
      var _result = (0, _isFunction2.default)(variants[i]) ? variants[i].apply(this, args) : variants[i];
      if (matcher.apply(this, [_result].concat(args))) {
        return _result;
      }
    }
    return (0, _isFunction2.default)(onFail) ? onFail.apply(this, args) : onFail;
  };
}
module.exports = exports['default'];